Package org.mariadb.jdbc

# Class BasePreparedStatement

java.lang.Object
org.mariadb.jdbc.Statement
org.mariadb.jdbc.BasePreparedStatement

All Implemented Interfaces:
  `AutoCloseable`, `PreparedStatement`, `Statement`, `Wrapper`

Direct Known Subclasses:
  `ClientPreparedStatement`, `ServerPreparedStatement`

public abstract class BasePreparedStatement extends Statement implements PreparedStatement
Common methods for prepare statement, for client and server prepare statement.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected List<Parameters>`
`batchParameters`
batching parameters
`protected final boolean`
`canCachePrepStmts`
Can cache PREPARE result (and reused them) *
`protected Parameters`
`parameters`
parameters
`protected Prepare`
`prepareResult`
PREPARE command result
`protected final String`
`sql`
prepare statement sql command

### Fields inherited from class org.mariadb.jdbc.Statement

`autoGeneratedKeys, canUseServerMaxRows, canUseServerTimeout, clientParser, closed, closeOnCompletion, con, currResult, escape, fetchSize, lastSql, localInfileInputStream, lock, maxRows, queryTimeout, results, resultSetConcurrency, resultSetType`

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

## Constructor Summary

Constructors
Constructor
Description
`BasePreparedStatement(String sql, Connection con, ClosableLock lock, boolean canUseServerTimeout, boolean canUseServerMaxRows, boolean canCachePrepStmts, int autoGeneratedKeys, int resultSetType, int resultSetConcurrency, int defaultFetchSize)`
Constructor

## Method Summary

Modifier and Type
Method
Description
`abstract void`
`addBatch()`
`void`
`addBatch(String sql)`
Adds the given SQL command to the current list of commands for this `Statement` object.
`void`
`clearBatch()`
Empties this `Statement` object's current list of SQL commands.
`void`
`clearParameters()`
Clears the current parameter values immediately.
`abstract boolean`
`execute()`
`boolean`
`execute(String sql)`
Executes the given SQL statement, which may return multiple results.
`boolean`
`execute(String sql, int autoGeneratedKeys)`
Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
`boolean`
`execute(String sql, int[] columnIndexes)`
Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`boolean`
`execute(String sql, String[] columnNames)`
Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int[]`
`executeBatch()`
Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
`protected void`
`executeBatchBulk(String cmd)`
Send COM_STMT_PREPARE + X * COM_STMT_BULK_EXECUTE, then read for the all answers
`protected abstract boolean`
`executeInternalPreparedBatch()`
`long[]`
`executeLargeBatch()`
Execute batch, like executeBatch(), with returning results with long[].
`abstract long`
`executeLargeUpdate()`
`long`
`executeLargeUpdate(String sql)`
Executes the given SQL statement, which may be an INSERT, UPDATE, or DELETE statement or an SQL statement that returns nothing, such as an SQL DDL statement.
`long`
`executeLargeUpdate(String sql, int autoGeneratedKeys)`
Identical to executeLargeUpdate(String sql), with a flag that indicate that autoGeneratedKeys (primary key fields with "auto_increment") generated id's must be retrieved.
`long`
`executeLargeUpdate(String sql, int[] columnIndexes)`
Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.
`long`
`executeLargeUpdate(String sql, String[] columnNames)`
Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.
`abstract ResultSet`
`executeQuery()`
`ResultSet`
`executeQuery(String sql)`
Executes the given SQL statement, which returns a single `ResultSet` object.
`abstract int`
`executeUpdate()`
`int`
`executeUpdate(String sql)`
Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.
`int`
`executeUpdate(String sql, int autoGeneratedKeys)`
Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
`int`
`executeUpdate(String sql, int[] columnIndexes)`
Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int`
`executeUpdate(String sql, String[] columnNames)`
Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`ResultSet`
`getGeneratedKeys()`
Retrieves any auto-generated keys created as a result of executing this `Statement` object.
`String`
`getLastSql()`
`org.mariadb.jdbc.client.ColumnDecoder[]`
`getMeta()`
Get cached metadata list
`abstract ResultSetMetaData`
`getMetaData()`
`abstract ParameterMetaData`
`getParameterMetaData()`
`void`
`reset()`
reset prepare statement in case of a failover.
`void`
`setArray(int parameterIndex, Array x)`
Sets the designated parameter to the given `java.sql.Array` object.
`void`
`setAsciiStream(int parameterIndex, InputStream x)`
Sets the designated parameter to the given input stream.
`void`
`setAsciiStream(int parameterIndex, InputStream x, int length)`
Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void`
`setAsciiStream(int parameterIndex, InputStream x, long length)`
Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void`
`setBigDecimal(int parameterIndex, BigDecimal x)`
Sets the designated parameter to the given `java.math.BigDecimal` value.
`void`
`setBinaryStream(int parameterIndex, InputStream x)`
Sets the designated parameter to the given input stream.
`void`
`setBinaryStream(int parameterIndex, InputStream x, int length)`
Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void`
`setBinaryStream(int parameterIndex, InputStream x, long length)`
Sets the designated parameter to the given input stream, which will have the specified number of bytes.
`void`
`setBlob(int parameterIndex, InputStream inputStream)`
Sets the designated parameter to a `InputStream` object.
`void`
`setBlob(int parameterIndex, InputStream inputStream, long length)`
Sets the designated parameter to a `InputStream` object.
`void`
`setBlob(int parameterIndex, Blob x)`
Sets the designated parameter to the given `java.sql.Blob` object.
`void`
`setBoolean(int parameterIndex, boolean x)`
Sets the designated parameter to the given Java `boolean` value.
`void`
`setByte(int parameterIndex, byte x)`
Sets the designated parameter to the given Java `byte` value.
`void`
`setBytes(int parameterIndex, byte[] x)`
Sets the designated parameter to the given Java array of bytes.
`void`
`setCharacterStream(int parameterIndex, Reader reader)`
Sets the designated parameter to the given `Reader` object.
`void`
`setCharacterStream(int parameterIndex, Reader reader, int length)`
Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void`
`setCharacterStream(int parameterIndex, Reader reader, long length)`
Sets the designated parameter to the given `Reader` object, which is the given number of characters long.
`void`
`setClob(int parameterIndex, Reader reader)`
Sets the designated parameter to a `Reader` object.
`void`
`setClob(int parameterIndex, Reader reader, long length)`
Sets the designated parameter to a `Reader` object.
`void`
`setClob(int parameterIndex, Clob x)`
Sets the designated parameter to the given `java.sql.Clob` object.
`void`
`setDate(int parameterIndex, Date x)`
Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application.
`void`
`setDate(int parameterIndex, Date x, Calendar cal)`
Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object.
`void`
`setDouble(int parameterIndex, double x)`
Sets the designated parameter to the given Java `double` value.
`void`
`setFloat(int parameterIndex, float x)`
Sets the designated parameter to the given Java `float` value.
`void`
`setInt(int parameterIndex, int x)`
Sets the designated parameter to the given Java `int` value.
`void`
`setLong(int parameterIndex, long x)`
Sets the designated parameter to the given Java `long` value.
`void`
`setNCharacterStream(int parameterIndex, Reader value)`
Sets the designated parameter to a `Reader` object.
`void`
`setNCharacterStream(int parameterIndex, Reader value, long length)`
Sets the designated parameter to a `Reader` object.
`void`
`setNClob(int parameterIndex, Reader reader)`
Sets the designated parameter to a `Reader` object.
`void`
`setNClob(int parameterIndex, Reader reader, long length)`
Sets the designated parameter to a `Reader` object.
`void`
`setNClob(int parameterIndex, NClob value)`
Sets the designated parameter to a `java.sql.NClob` object.
`void`
`setNString(int parameterIndex, String value)`
Sets the designated parameter to the given `String` object.
`void`
`setNull(int parameterIndex, int sqlType)`
Sets the designated parameter to SQL `NULL`.
`void`
`setNull(int parameterIndex, int sqlType, String typeName)`
Sets the designated parameter to SQL `NULL`.
`void`
`setObject(int parameterIndex, Object x)`
Sets the value of the designated parameter using the given object.
`void`
`setObject(int parameterIndex, Object x, int targetSqlType)`
Sets the value of the designated parameter with the given object.
`void`
`setObject(int parameterIndex, Object x, int targetSqlType, int scaleOrLength)`
Sets the value of the designated parameter with the given object.
`void`
`setObject(int parameterIndex, Object x, SQLType targetSqlType)`
Sets the value of the designated parameter with the given object.
`void`
`setObject(int parameterIndex, Object x, SQLType targetSqlType, int scaleOrLength)`
Sets the value of the designated parameter with the given object.
`void`
`setParameter(int index, Parameter param)`
Set parameter
`void`
`setParameters(Parameters parameters)`
Set all parameters
`void`
`setPrepareResult(Prepare prepareResult)`
Set PREPARE result
`void`
`setRef(int parameterIndex, Ref x)`
Sets the designated parameter to the given `REF(<structured-type>)` value.
`void`
`setRowId(int parameterIndex, RowId x)`
Sets the designated parameter to the given `java.sql.RowId` object.
`void`
`setShort(int parameterIndex, short x)`
Sets the designated parameter to the given Java `short` value.
`void`
`setSQLXML(int parameterIndex, SQLXML xmlObject)`
Sets the designated parameter to the given `java.sql.SQLXML` object.
`void`
`setString(int parameterIndex, String x)`
Sets the designated parameter to the given Java `String` value.
`void`
`setTime(int parameterIndex, Time x)`
Sets the designated parameter to the given `java.sql.Time` value.
`void`
`setTime(int parameterIndex, Time x, Calendar cal)`
Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object.
`void`
`setTimestamp(int parameterIndex, Timestamp x)`
Sets the designated parameter to the given `java.sql.Timestamp` value.
`void`
`setTimestamp(int parameterIndex, Timestamp x, Calendar cal)`
Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object.
`void`
`setUnicodeStream(int parameterIndex, InputStream x, int length)`
Deprecated.
Use `setCharacterStream`
`void`
`setURL(int parameterIndex, URL x)`
Sets the designated parameter to the given `java.net.URL` value.
`String`
`toString()`
`void`
`updateMeta(org.mariadb.jdbc.client.ColumnDecoder[] ci)`
update cached metadata list

### Methods inherited from class org.mariadb.jdbc.Statement

`abort, cancel, checkNotClosed, clearWarnings, close, closeOnCompletion, enquoteIdentifier, enquoteLiteral, enquoteNCharLiteral, escapeTimeout, executeInternalBatchPipeline, executeInternalBatchStandard, fetchRemaining, getConnection, getFetchDirection, getFetchSize, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, isSimpleIdentifier, isWrapperFor, parseCommandIfNeeded, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setLocalInfileInputStream, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout, unwrap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.sql.Statement

`cancel, clearWarnings, close, closeOnCompletion, enquoteIdentifier, enquoteLiteral, enquoteNCharLiteral, getConnection, getFetchDirection, getFetchSize, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, isSimpleIdentifier, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor, unwrap`

## Field Details

### sql

protected final String sql
prepare statement sql command

### parameters

protected Parameters parameters
parameters

### batchParameters

protected List<Parameters> batchParameters
batching parameters

### prepareResult

protected Prepare prepareResult
PREPARE command result

### canCachePrepStmts

protected final boolean canCachePrepStmts
Can cache PREPARE result (and reused them) *

## Constructor Details

### BasePreparedStatement

public BasePreparedStatement(String sql, Connection con, ClosableLock lock, boolean canUseServerTimeout, boolean canUseServerMaxRows, boolean canCachePrepStmts, int autoGeneratedKeys, int resultSetType, int resultSetConcurrency, int defaultFetchSize)
Constructor

Parameters:
  `sql` - sql command
  `con` - connection
  `lock` - thread safe lock
  `canUseServerTimeout` - indicate if server can support server timeout
  `canUseServerMaxRows` - indicate if server can support max rows
  `canCachePrepStmts` - can cache prepared statement
  `autoGeneratedKeys` - indicate if automatif generated key retrival is required
  `resultSetType` - resultset type
  `resultSetConcurrency` - resultset concurrency
  `defaultFetchSize` - default fetch size

## Method Details

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### getLastSql

public String getLastSql()

Overrides:
  `getLastSql` in class `Statement`

### setPrepareResult

public void setPrepareResult(Prepare prepareResult)
Set PREPARE result

Parameters:
  `prepareResult` - prepare result

### getMeta

public org.mariadb.jdbc.client.ColumnDecoder[] getMeta()
Get cached metadata list

Returns:
  metadata list

### updateMeta

public void updateMeta(org.mariadb.jdbc.client.ColumnDecoder[] ci)
update cached metadata list

Parameters:
  `ci` - metadata columns

### execute

public abstract boolean execute() throws SQLException

Specified by:
  `execute` in interface `PreparedStatement`
Throws:
  `SQLException`

### executeQuery

public abstract ResultSet executeQuery() throws SQLException

Specified by:
  `executeQuery` in interface `PreparedStatement`
Throws:
  `SQLException`

### executeUpdate

public abstract int executeUpdate() throws SQLException

Specified by:
  `executeUpdate` in interface `PreparedStatement`
Throws:
  `SQLException`

### executeLargeUpdate

public abstract long executeLargeUpdate() throws SQLException

Specified by:
  `executeLargeUpdate` in interface `PreparedStatement`
Throws:
  `SQLException`

### addBatch

public abstract void addBatch() throws SQLException

Specified by:
  `addBatch` in interface `PreparedStatement`
Throws:
  `SQLException`

### getMetaData

public abstract ResultSetMetaData getMetaData() throws SQLException

Specified by:
  `getMetaData` in interface `PreparedStatement`
Throws:
  `SQLException`

### getParameterMetaData

public abstract ParameterMetaData getParameterMetaData() throws SQLException

Specified by:
  `getParameterMetaData` in interface `PreparedStatement`
Throws:
  `SQLException`

### setParameters

public void setParameters(Parameters parameters)
Set all parameters

Parameters:
  `parameters` - parameters

### setParameter

public void setParameter(int index, Parameter param)
Set parameter

Parameters:
  `index` - parameter index
  `param` - parameter

### addBatch

public void addBatch(String sql) throws SQLException
Description copied from class: `Statement`
Adds the given SQL command to the current list of commands for this `Statement` object. The commands in this list can be executed as a batch by calling the method `executeBatch`.

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `addBatch` in interface `Statement`
Overrides:
  `addBatch` in class `Statement`
Parameters:
  `sql` - typically this is an SQL `INSERT` or `UPDATE` statement
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the driver does not support batch updates, the method is called on a `PreparedStatement` or `CallableStatement`
See Also:
  - `Statement.executeBatch()`
  - `DatabaseMetaData.supportsBatchUpdates()`

### execute

public boolean execute(String sql) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement, which may return multiple results. In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Overrides:
  `execute` in class `Statement`
Parameters:
  `sql` - any SQL statement
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the method is called on a `PreparedStatement` or `CallableStatement`
See Also:
  - `Statement.getResultSet()`
  - `Statement.getUpdateCount()`
  - `Statement.getMoreResults()`

### execute

public boolean execute(String sql, int autoGeneratedKeys) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Overrides:
  `execute` in class `Statement`
Parameters:
  `sql` - any SQL statement
  `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method `getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the second parameter supplied to this method is not `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`, the method is called on a `PreparedStatement` or `CallableStatement`
See Also:
  - `Statement.getResultSet()`
  - `Statement.getUpdateCount()`
  - `Statement.getMoreResults()`
  - `Statement.getGeneratedKeys()`

### execute

public boolean execute(String sql, int[] columnIndexes) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Overrides:
  `execute` in class `Statement`
Parameters:
  `sql` - any SQL statement
  `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the elements in the `int` array passed to this method are not valid column indexes, the method is called on a `PreparedStatement` or `CallableStatement`
See Also:
  - `Statement.getResultSet()`
  - `Statement.getUpdateCount()`
  - `Statement.getMoreResults()`

### execute

public boolean execute(String sql, String[] columnNames) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `execute` in interface `Statement`
Overrides:
  `execute` in class `Statement`
Parameters:
  `sql` - any SQL statement
  `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
Returns:
  `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`,the elements of the `String` array passed to this method are not valid column names, the method is called on a `PreparedStatement` or `CallableStatement`
See Also:
  - `Statement.getResultSet()`
  - `Statement.getUpdateCount()`
  - `Statement.getMoreResults()`
  - `Statement.getGeneratedKeys()`

### executeQuery

public ResultSet executeQuery(String sql) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement, which returns a single `ResultSet` object.

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeQuery` in interface `Statement`
Overrides:
  `executeQuery` in class `Statement`
Parameters:
  `sql` - an SQL statement to be sent to the database, typically a static SQL `SELECT` statement
Returns:
  a `ResultSet` object that contains the data produced by the given query; never `null`
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement produces anything other than a single `ResultSet` object, the method is called on a `PreparedStatement` or `CallableStatement`

### executeUpdate

public int executeUpdate(String sql) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Overrides:
  `executeUpdate` in class `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement produces a `ResultSet` object, the method is called on a `PreparedStatement` or `CallableStatement`

### executeUpdate

public int executeUpdate(String sql, int autoGeneratedKeys) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval. The driver will ignore the flag if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Overrides:
  `executeUpdate` in class `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the given SQL statement returns a `ResultSet` object, the given constant is not one of those allowed, the method is called on a `PreparedStatement` or `CallableStatement`

### executeUpdate

public int executeUpdate(String sql, int[] columnIndexes) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Overrides:
  `executeUpdate` in class `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
Returns:
  either (1) the row count for SQL Data Manipulation Language (DML) statements or (2) 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object,the second argument supplied to this method is not an `int` array whose elements are valid column indexes, the method is called on a `PreparedStatement` or `CallableStatement`

### executeUpdate

public int executeUpdate(String sql, String[] columnNames) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the SQL statement is not an `INSERT` statement, or an SQL statement able to return auto-generated keys (the list of such statements is vendor-specific).

Note:This method cannot be called on a `PreparedStatement` or `CallableStatement`.

Specified by:
  `executeUpdate` in interface `Statement`
Overrides:
  `executeUpdate` in class `Statement`
Parameters:
  `sql` - an SQL Data Manipulation Language (DML) statement, such as `INSERT`, `UPDATE` or `DELETE`; or an SQL statement that returns nothing, such as a DDL statement.
  `columnNames` - an array of the names of the columns that should be returned from the inserted row
Returns:
  either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement`, the SQL statement returns a `ResultSet` object, the second argument supplied to this method is not a `String` array whose elements are valid column names, the method is called on a `PreparedStatement` or `CallableStatement`

### executeLargeUpdate

public long executeLargeUpdate(String sql) throws SQLException
Description copied from class: `Statement`
Executes the given SQL statement, which may be an INSERT, UPDATE, or DELETE statement or an SQL statement that returns nothing, such as an SQL DDL statement. This method should be used when the returned row count may exceed Integer.MAX_VALUE.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Overrides:
  `executeLargeUpdate` in class `Statement`
Parameters:
  `sql` - sql command
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

### executeLargeUpdate

public long executeLargeUpdate(String sql, int autoGeneratedKeys) throws SQLException
Description copied from class: `Statement`
Identical to executeLargeUpdate(String sql), with a flag that indicate that autoGeneratedKeys (primary key fields with "auto_increment") generated id's must be retrieved.

Those id's will be available using getGeneratedKeys() method.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Overrides:
  `executeLargeUpdate` in class `Statement`
Parameters:
  `sql` - sql command
  `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: Statement.RETURN_GENERATED_KEYS Statement.NO_GENERATED_KEYS
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

### executeLargeUpdate

public long executeLargeUpdate(String sql, int[] columnIndexes) throws SQLException
Description copied from class: `Statement`
Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Overrides:
  `executeLargeUpdate` in class `Statement`
Parameters:
  `sql` - sql command
  `columnIndexes` - column Indexes
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

### executeLargeUpdate

public long executeLargeUpdate(String sql, String[] columnNames) throws SQLException
Description copied from class: `Statement`
Identical to executeLargeUpdate(String sql, int autoGeneratedKeys) with autoGeneratedKeys = Statement.RETURN_GENERATED_KEYS set.

Specified by:
  `executeLargeUpdate` in interface `Statement`
Overrides:
  `executeLargeUpdate` in class `Statement`
Parameters:
  `sql` - sql command
  `columnNames` - columns names
Returns:
  update counts
Throws:
  `SQLException` - if any error occur during execution

### setNull

public void setNull(int parameterIndex, int sqlType) throws SQLException
Sets the designated parameter to SQL `NULL`.

Note: You must specify the parameter's SQL type.

Specified by:
  `setNull` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `sqlType` - the SQL type code defined in `java.sql.Types`
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type

### setBoolean

public void setBoolean(int parameterIndex, boolean x) throws SQLException
Sets the designated parameter to the given Java `boolean` value. The driver converts this to an SQL `BIT` or `BOOLEAN` value when it sends it to the database.

Specified by:
  `setBoolean` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setByte

public void setByte(int parameterIndex, byte x) throws SQLException
Sets the designated parameter to the given Java `byte` value. The driver converts this to an SQL `TINYINT` value when it sends it to the database.

Specified by:
  `setByte` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setShort

public void setShort(int parameterIndex, short x) throws SQLException
Sets the designated parameter to the given Java `short` value. The driver converts this to an SQL `SMALLINT` value when it sends it to the database.

Specified by:
  `setShort` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setInt

public void setInt(int parameterIndex, int x) throws SQLException
Sets the designated parameter to the given Java `int` value. The driver converts this to an SQL `INTEGER` value when it sends it to the database.

Specified by:
  `setInt` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setLong

public void setLong(int parameterIndex, long x) throws SQLException
Sets the designated parameter to the given Java `long` value. The driver converts this to an SQL `BIGINT` value when it sends it to the database.

Specified by:
  `setLong` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setFloat

public void setFloat(int parameterIndex, float x) throws SQLException
Sets the designated parameter to the given Java `float` value. The driver converts this to an SQL `REAL` value when it sends it to the database.

Specified by:
  `setFloat` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setDouble

public void setDouble(int parameterIndex, double x) throws SQLException
Sets the designated parameter to the given Java `double` value. The driver converts this to an SQL `DOUBLE` value when it sends it to the database.

Specified by:
  `setDouble` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setBigDecimal

public void setBigDecimal(int parameterIndex, BigDecimal x) throws SQLException
Sets the designated parameter to the given `java.math.BigDecimal` value. The driver converts this to an SQL `NUMERIC` value when it sends it to the database.

Specified by:
  `setBigDecimal` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setString

public void setString(int parameterIndex, String x) throws SQLException
Sets the designated parameter to the given Java `String` value. The driver converts this to an SQL `VARCHAR` or `LONGVARCHAR` value (depending on the argument's size relative to the driver's limits on `VARCHAR` values) when it sends it to the database.

Specified by:
  `setString` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setBytes

public void setBytes(int parameterIndex, byte[] x) throws SQLException
Sets the designated parameter to the given Java array of bytes. The driver converts this to an SQL `VARBINARY` or `LONGVARBINARY` (depending on the argument's size relative to the driver's limits on `VARBINARY` values) when it sends it to the database.

Specified by:
  `setBytes` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setDate

public void setDate(int parameterIndex, Date x) throws SQLException
Sets the designated parameter to the given `java.sql.Date` value using the default time zone of the virtual machine that is running the application. The driver converts this to an SQL `DATE` value when it sends it to the database.

Specified by:
  `setDate` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setTime

public void setTime(int parameterIndex, Time x) throws SQLException
Sets the designated parameter to the given `java.sql.Time` value. The driver converts this to an SQL `TIME` value when it sends it to the database.

Specified by:
  `setTime` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setTimestamp

public void setTimestamp(int parameterIndex, Timestamp x) throws SQLException
Sets the designated parameter to the given `java.sql.Timestamp` value. The driver converts this to an SQL `TIMESTAMP` value when it sends it to the database.

Specified by:
  `setTimestamp` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setAsciiStream

public void setAsciiStream(int parameterIndex, InputStream x, int length) throws SQLException
Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the Java input stream that contains the ASCII parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### setUnicodeStream

@Deprecated public void setUnicodeStream(int parameterIndex, InputStream x, int length) throws SQLException
Deprecated.
Use `setCharacterStream`
Sets the designated parameter to the given input stream, which will have the specified number of bytes.

When a very large Unicode value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from Unicode to the database char format.

The byte format of the Unicode stream must be a Java UTF-8, as defined in the Java Virtual Machine Specification.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setUnicodeStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - a `java.io.InputStream` object that contains the Unicode parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method

### setBinaryStream

public void setBinaryStream(int parameterIndex, InputStream x, int length) throws SQLException
Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java input stream which contains the binary parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`

### clearParameters

public void clearParameters() throws SQLException
Clears the current parameter values immediately.

In general, parameter values remain in force for repeated use of a statement. Setting a parameter value automatically clears its previous value. However, in some cases it is useful to immediately release the resources used by the current parameter values; this can be done by calling the method `clearParameters`.

Specified by:
  `clearParameters` in interface `PreparedStatement`
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `PreparedStatement`

### clearBatch

public void clearBatch() throws SQLException
Description copied from class: `Statement`
Empties this `Statement` object's current list of SQL commands.

Specified by:
  `clearBatch` in interface `Statement`
Overrides:
  `clearBatch` in class `Statement`
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch updates
See Also:
  - `Statement.addBatch(java.lang.String)`
  - `DatabaseMetaData.supportsBatchUpdates()`

### setObject

public void setObject(int parameterIndex, Object x, int targetSqlType) throws SQLException
Sets the value of the designated parameter with the given object.

This method is similar to `setObject(int parameterIndex, Object x, int targetSqlType, int scaleOrLength)`, except that it assumes a scale of zero.

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the object containing the input parameter value
  `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed PreparedStatement
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
See Also:
  - `Types`

### setObject

public void setObject(int parameterIndex, Object x) throws SQLException
Sets the value of the designated parameter using the given object.

The JDBC specification specifies a standard mapping from Java `Object` types to SQL types. The given argument will be converted to the corresponding SQL type before being sent to the database.

Note that this method may be used to pass datatabase- specific abstract data types, by using a driver-specific Java type.

If the object is of a class implementing the interface `SQLData`, the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, `RowId`, `SQLXML` or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

Note: Not all databases allow for a non-typed Null to be sent to the backend. For maximum portability, the `setNull` or the `setObject(int parameterIndex, Object x, int sqlType)` method should be used instead of `setObject(int parameterIndex, Object x)`.

Note: This method throws an exception if there is an ambiguity, for example, if the object is of a class implementing more than one of the interfaces named above.

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the object containing the input parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or the type of the given object is ambiguous

### setCharacterStream

public void setCharacterStream(int parameterIndex, Reader reader, int length) throws SQLException
Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `reader` - the `java.io.Reader` object that contains the Unicode data
  `length` - the number of characters in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.2

### setRef

public void setRef(int parameterIndex, Ref x) throws SQLException
Sets the designated parameter to the given `REF(<structured-type>)` value. The driver converts this to an SQL `REF` value when it sends it to the database.

Specified by:
  `setRef` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - an SQL `REF` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

### setBlob

public void setBlob(int parameterIndex, Blob x) throws SQLException
Sets the designated parameter to the given `java.sql.Blob` object. The driver converts this to an SQL `BLOB` value when it sends it to the database.

Specified by:
  `setBlob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - a `Blob` object that maps an SQL `BLOB` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

### setClob

public void setClob(int parameterIndex, Clob x) throws SQLException
Sets the designated parameter to the given `java.sql.Clob` object. The driver converts this to an SQL `CLOB` value when it sends it to the database.

Specified by:
  `setClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - a `Clob` object that maps an SQL `CLOB` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

### setArray

public void setArray(int parameterIndex, Array x) throws SQLException
Sets the designated parameter to the given `java.sql.Array` object. The driver converts this to an SQL `ARRAY` value when it sends it to the database.

Specified by:
  `setArray` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - an `Array` object that maps an SQL `ARRAY` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.2

### setDate

public void setDate(int parameterIndex, Date x, Calendar cal) throws SQLException
Sets the designated parameter to the given `java.sql.Date` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `DATE` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the date taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setDate` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the date
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.2

### setTime

public void setTime(int parameterIndex, Time x, Calendar cal) throws SQLException
Sets the designated parameter to the given `java.sql.Time` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIME` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the time taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setTime` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the time
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.2

### setTimestamp

public void setTimestamp(int parameterIndex, Timestamp x, Calendar cal) throws SQLException
Sets the designated parameter to the given `java.sql.Timestamp` value, using the given `Calendar` object. The driver uses the `Calendar` object to construct an SQL `TIMESTAMP` value, which the driver then sends to the database. With a `Calendar` object, the driver can calculate the timestamp taking into account a custom timezone. If no `Calendar` object is specified, the driver uses the default timezone, which is that of the virtual machine running the application.

Specified by:
  `setTimestamp` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
  `cal` - the `Calendar` object the driver will use to construct the timestamp
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.2

### setNull

public void setNull(int parameterIndex, int sqlType, String typeName) throws SQLException
Sets the designated parameter to SQL `NULL`. This version of the method `setNull` should be used for user-defined types and REF type parameters. Examples of user-defined types include: STRUCT, DISTINCT, JAVA_OBJECT, and named array types.

Note: To be portable, applications must give the SQL type code and the fully-qualified SQL type name when specifying a NULL user-defined or REF parameter. In the case of a user-defined type the name is the type name of the parameter itself. For a REF parameter, the name is the type name of the referenced type. If a JDBC driver does not need the type code or type name information, it may ignore it.

Although it is intended for user-defined and Ref parameters, this method may be used to set a null parameter of any JDBC type. If the parameter does not have a user-defined or REF type, the given typeName is ignored.

Specified by:
  `setNull` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `sqlType` - a value from `java.sql.Types`
  `typeName` - the fully-qualified name of an SQL user-defined type; ignored if the parameter is not a user-defined type or REF
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if `sqlType` is a `ARRAY`, `BLOB`, `CLOB`, `DATALINK`, `JAVA_OBJECT`, `NCHAR`, `NCLOB`, `NVARCHAR`, `LONGNVARCHAR`, `REF`, `ROWID`, `SQLXML` or `STRUCT` data type and the JDBC driver does not support this data type or if the JDBC driver does not support this method
Since:
  1.2

### setURL

public void setURL(int parameterIndex, URL x) throws SQLException
Sets the designated parameter to the given `java.net.URL` value. The driver converts this to an SQL `DATALINK` value when it sends it to the database.

Specified by:
  `setURL` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the `java.net.URL` object to be set
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.4

### setRowId

public void setRowId(int parameterIndex, RowId x) throws SQLException
Sets the designated parameter to the given `java.sql.RowId` object. The driver converts this to an SQL `ROWID` value when it sends it to the database

Specified by:
  `setRowId` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setNString

public void setNString(int parameterIndex, String value) throws SQLException
Sets the designated parameter to the given `String` object. The driver converts this to an SQL `NCHAR` or `NVARCHAR` or `LONGNVARCHAR` value (depending on the argument's size relative to the driver's limits on `NVARCHAR` values) when it sends it to the database.

Specified by:
  `setNString` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setNCharacterStream

public void setNCharacterStream(int parameterIndex, Reader value, long length) throws SQLException
Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Specified by:
  `setNCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setNClob

public void setNClob(int parameterIndex, NClob value) throws SQLException
Sets the designated parameter to a `java.sql.NClob` object. The driver converts this to an SQL `NCLOB` value when it sends it to the database.

Specified by:
  `setNClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setClob

public void setClob(int parameterIndex, Reader reader, long length) throws SQLException
Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`

Specified by:
  `setClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if the length specified is less than zero.
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setBlob

public void setBlob(int parameterIndex, InputStream inputStream, long length) throws SQLException
Sets the designated parameter to a `InputStream` object. The inputstream must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setBinaryStream (int, InputStream, int)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

Specified by:
  `setBlob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
  `length` - the number of bytes in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement`; if the length specified is less than zero or if the number of bytes in the inputstream does not match the specified length.
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setNClob

public void setNClob(int parameterIndex, Reader reader, long length) throws SQLException
Sets the designated parameter to a `Reader` object. The reader must contain the number of characters specified by length otherwise a `SQLException` will be generated when the `PreparedStatement` is executed. This method differs from the `setCharacterStream (int, Reader, int)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`

Specified by:
  `setNClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
  `length` - the number of characters in the parameter data.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the length specified is less than zero; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setSQLXML

public void setSQLXML(int parameterIndex, SQLXML xmlObject) throws SQLException
Sets the designated parameter to the given `java.sql.SQLXML` object. The driver converts this to an SQL `XML` value when it sends it to the database.

Specified by:
  `setSQLXML` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `xmlObject` - a `SQLXML` object that maps an SQL `XML` value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or the `java.xml.transform.Result`, `Writer` or `OutputStream` has not been closed for the `SQLXML` object
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setObject

public void setObject(int parameterIndex, Object x, int targetSqlType, int scaleOrLength) throws SQLException
Sets the value of the designated parameter with the given object.

If the second argument is an `InputStream` then the stream must contain the number of bytes specified by scaleOrLength. If the second argument is a `Reader` then the reader must contain the number of characters specified by scaleOrLength. If these conditions are not true the driver will generate a `SQLException` when the prepared statement is executed.

The given Java object will be converted to the given targetSqlType before being sent to the database.

If the object has a custom mapping (is of a class implementing the interface `SQLData` ), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref` , `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

Note that this method may be used to pass database-specific abstract data types.

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the object containing the input parameter value
  `targetSqlType` - the SQL type (as defined in java.sql.Types) to be sent to the database. The scale argument may further qualify this type.
  `scaleOrLength` - for `java.sql.Types.DECIMAL` or `java.sql.Types.NUMERIC types`, this is the number of digits after the decimal point. For Java Object types `InputStream` and `Reader`, this is the length of the data in the stream or reader. For all other types, this value will be ignored.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if the Java Object specified by x is an InputStream or Reader object and the value of the scale parameter is less than zero
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
See Also:
  - `Types`

### setAsciiStream

public void setAsciiStream(int parameterIndex, InputStream x, long length) throws SQLException
Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the Java input stream that contains the ASCII parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.6

### setBinaryStream

public void setBinaryStream(int parameterIndex, InputStream x, long length) throws SQLException
Sets the designated parameter to the given input stream, which will have the specified number of bytes. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java input stream which contains the binary parameter value
  `length` - the number of bytes in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.6

### setCharacterStream

public void setCharacterStream(int parameterIndex, Reader reader, long length) throws SQLException
Sets the designated parameter to the given `Reader` object, which is the given number of characters long. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `reader` - the `java.io.Reader` object that contains the Unicode data
  `length` - the number of characters in the stream
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
Since:
  1.6

### setAsciiStream

public void setAsciiStream(int parameterIndex, InputStream x) throws SQLException
Sets the designated parameter to the given input stream. When a very large ASCII value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.InputStream`. Data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from ASCII to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setAsciiStream` which takes a length parameter.

Specified by:
  `setAsciiStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the Java input stream that contains the ASCII parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setBinaryStream

public void setBinaryStream(int parameterIndex, InputStream x) throws SQLException
Sets the designated parameter to the given input stream. When a very large binary value is input to a `LONGVARBINARY` parameter, it may be more practical to send it via a `java.io.InputStream` object. The data will be read from the stream as needed until end-of-file is reached.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBinaryStream` which takes a length parameter.

Specified by:
  `setBinaryStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the java input stream which contains the binary parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setCharacterStream

public void setCharacterStream(int parameterIndex, Reader reader) throws SQLException
Sets the designated parameter to the given `Reader` object. When a very large UNICODE value is input to a `LONGVARCHAR` parameter, it may be more practical to send it via a `java.io.Reader` object. The data will be read from the stream as needed until end-of-file is reached. The JDBC driver will do any necessary conversion from UNICODE to the database char format.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setCharacterStream` which takes a length parameter.

Specified by:
  `setCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `reader` - the `java.io.Reader` object that contains the Unicode data
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setNCharacterStream

public void setNCharacterStream(int parameterIndex, Reader value) throws SQLException
Sets the designated parameter to a `Reader` object. The `Reader` reads the data till end-of-file is reached. The driver does the necessary conversion from Java character format to the national character set in the database.

Note: This stream object can either be a standard Java stream object or your own subclass that implements the standard interface.

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNCharacterStream` which takes a length parameter.

Specified by:
  `setNCharacterStream` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - of the first parameter is 1, the second is 2, ...
  `value` - the parameter value
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs; or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setClob

public void setClob(int parameterIndex, Reader reader) throws SQLException
Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `CLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARCHAR` or a `CLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setClob` which takes a length parameter.

Specified by:
  `setClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement`or if parameterIndex does not correspond to a parameter marker in the SQL statement
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setBlob

public void setBlob(int parameterIndex, InputStream inputStream) throws SQLException
Sets the designated parameter to a `InputStream` object. This method differs from the `setBinaryStream (int, InputStream)` method because it informs the driver that the parameter value should be sent to the server as a `BLOB`. When the `setBinaryStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGVARBINARY` or a `BLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setBlob` which takes a length parameter.

Specified by:
  `setBlob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `inputStream` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs; this method is called on a closed `PreparedStatement` or if parameterIndex does not correspond to a parameter marker in the SQL statement,
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setNClob

public void setNClob(int parameterIndex, Reader reader) throws SQLException
Sets the designated parameter to a `Reader` object. This method differs from the `setCharacterStream (int, Reader)` method because it informs the driver that the parameter value should be sent to the server as a `NCLOB`. When the `setCharacterStream` method is used, the driver may have to do extra work to determine whether the parameter data should be sent to the server as a `LONGNVARCHAR` or a `NCLOB`

Note: Consult your JDBC driver documentation to determine if it might be more efficient to use a version of `setNClob` which takes a length parameter.

Specified by:
  `setNClob` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - index of the first parameter is 1, the second is 2, ...
  `reader` - An object that contains the data to set the parameter value to.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if the driver does not support national character sets; if the driver can detect that a data conversion error could occur; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support this method
Since:
  1.6

### setObject

public void setObject(int parameterIndex, Object x, SQLType targetSqlType, int scaleOrLength) throws SQLException
Sets the value of the designated parameter with the given object.

If the second argument is an `InputStream` then the stream must contain the number of bytes specified by scaleOrLength. If the second argument is a `Reader` then the reader must contain the number of characters specified by scaleOrLength. If these conditions are not true the driver will generate a `SQLException` when the prepared statement is executed.

The given Java object will be converted to the given targetSqlType before being sent to the database.

If the object has a custom mapping (is of a class implementing the interface `SQLData`), the JDBC driver should call the method `SQLData.writeSQL` to write it to the SQL data stream. If, on the other hand, the object is of a class implementing `Ref`, `Blob`, `Clob`, `NClob`, `Struct`, `java.net.URL`, or `Array`, the driver should pass it to the database as a value of the corresponding SQL type.

Note that this method may be used to pass database-specific abstract data types.

The default implementation will throw `SQLFeatureNotSupportedException`

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the object containing the input parameter value
  `targetSqlType` - the SQL type to be sent to the database. The scale argument may further qualify this type.
  `scaleOrLength` - for `java.sql.JDBCType.DECIMAL` or `java.sql.JDBCType.NUMERIC types`, this is the number of digits after the decimal point. For Java Object types `InputStream` and `Reader`, this is the length of the data in the stream or reader. For all other types, this value will be ignored.
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement` or if the Java Object specified by x is an InputStream or Reader object and the value of the scale parameter is less than zero
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
Since:
  1.8
See Also:
  - `JDBCType`
  - `SQLType`

### setObject

public void setObject(int parameterIndex, Object x, SQLType targetSqlType) throws SQLException
Sets the value of the designated parameter with the given object.

This method is similar to `setObject(int parameterIndex, Object x, SQLType targetSqlType, int scaleOrLength)`, except that it assumes a scale of zero.

The default implementation will throw `SQLFeatureNotSupportedException`

Specified by:
  `setObject` in interface `PreparedStatement`
Parameters:
  `parameterIndex` - the first parameter is 1, the second is 2, ...
  `x` - the object containing the input parameter value
  `targetSqlType` - the SQL type to be sent to the database
Throws:
  `SQLException` - if parameterIndex does not correspond to a parameter marker in the SQL statement; if a database access error occurs or this method is called on a closed `PreparedStatement`
  `SQLFeatureNotSupportedException` - if the JDBC driver does not support the specified targetSqlType
Since:
  1.8
See Also:
  - `JDBCType`
  - `SQLType`

### executeInternalPreparedBatch

protected abstract boolean executeInternalPreparedBatch() throws SQLException

Throws:
  `SQLException`

### executeBatch

public int[] executeBatch() throws SQLException
Description copied from class: `Statement`
Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:

1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

   If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to process commands in a batch update after a `BatchUpdateException` object has been thrown.

Specified by:
  `executeBatch` in interface `Statement`
Overrides:
  `executeBatch` in class `Statement`
Returns:
  an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.
Throws:
  `SQLException` - if a database access error occurs, this method is called on a closed `Statement` or the driver does not support batch statements. Throws `BatchUpdateException` (a subclass of `SQLException`) if one of the commands sent to the database fails to execute properly or attempts to return a result set.
See Also:
  - `Statement.addBatch(java.lang.String)`
  - `DatabaseMetaData.supportsBatchUpdates()`

### executeLargeBatch

public long[] executeLargeBatch() throws SQLException
Description copied from class: `Statement`
Execute batch, like executeBatch(), with returning results with long[]. For when row count may exceed Integer.MAX_VALUE.

Specified by:
  `executeLargeBatch` in interface `Statement`
Overrides:
  `executeLargeBatch` in class `Statement`
Returns:
  an array of update counts (one element for each command in the batch)
Throws:
  `SQLException` - if a database error occur.

### executeBatchBulk

protected void executeBatchBulk(String cmd) throws SQLException
Send COM_STMT_PREPARE + X * COM_STMT_BULK_EXECUTE, then read for the all answers

Parameters:
  `cmd` - command
Throws:
  `SQLException` - if IOException / Command error

### reset

public void reset()
reset prepare statement in case of a failover. (Command need then to be re-prepared on server)

### getGeneratedKeys

public ResultSet getGeneratedKeys() throws SQLException
Description copied from class: `Statement`
Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

Note:If the columns which represent the auto-generated keys were not specified, the JDBC driver implementation will determine the columns which best represent the auto-generated keys.

Specified by:
  `getGeneratedKeys` in interface `Statement`
Overrides:
  `getGeneratedKeys` in class `Statement`
Returns:
  a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object
Throws:
  `SQLException` - if a database access error occurs or this method is called on a closed `Statement`